<script setup lang="ts">
import { useExpensesStore } from '@/stores/expenses'
import type { Expenses } from '@/types/Expenses'
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Branch Name',
    key: 'branchName',
    value: 'branchName'
  },
  {
    title: 'Bill Type',
    key: 'billType',
    value: 'billType'
  },
  {
    title: 'Total Amount',
    key: 'totalAmount',
    value: 'totalAmount'
  },
  { title: '', key: 'actions', sortable: false }
]

const itemsPerPage = ref<any>(10)
const page = ref(1)
const pageCount = computed(() => {
  return Math.ceil(expensesStore.expensess.length / itemsPerPage.value)
})
const expensesStore = useExpensesStore()
const search = ref('')
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)

const filteredExpenses = computed(() => {
  return expensesStore.expensess.filter((expensess) =>
    expensess.branchName.toUpperCase().includes(search.value.toUpperCase())
  )
})

function onSubmit() {}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await expensesStore.saveExpenses()
  closeDialog()
}

async function deleteItem(item: Expenses) {
  if (!item.id) return
  await expensesStore.getExpenses(item.id)
  dialogDelete.value = true
}

async function deleteItemConfirm() {
  await expensesStore.deleteExpenses()
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
}

async function editItem(item: Expenses) {
  if (!item.id) return
  await expensesStore.getExpenses(item.id)
  dialog.value = true
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
}

onMounted(async () => {
  await expensesStore.getExpensess()
})
</script>

<template>
  <div style="width: 95%; height: 100%">
    <v-data-table-virtual
      v-model:page="page"
      :headers="headers"
      :items="filteredExpenses"
      :items-per-page="itemsPerPage"
    >
      <template v-slot:top>
        <v-toolbar flat color="#F48FB1">
          <v-toolbar-title>
            <v-icon icon="mdi-branch"></v-icon>
            Expenses</v-toolbar-title
          >
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-text-field
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="outlined"
            style="margin-right: 20px"
          ></v-text-field>

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn class="mx-2" color="#ECEFF1" variant="flat" v-bind="props">
                <v-icon icon="mdi-plus"> </v-icon>
                Add Expenses
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Add Expenses</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="expensesStore.editedExpenses.branchId"
                          :readonly="loading"
                          :rules="[(v) => !/[^0-9]/g.test(v)]"
                          class="mb-2"
                          clearable
                          label="Branch ID"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-combobox
                          v-model="expensesStore.editedExpenses.billType"
                          :items="['Electricity', 'Water', 'Other']"
                          label="Type"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="expensesStore.editedExpenses.totalAmount"
                          :readonly="loading"
                          :rules="[(v) => !/[^0-9]/g.test(v)]"
                          class="mb-2"
                          clearable
                          label="Amount"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog"> Close </v-btn>
                <v-btn color="green" variant="flat" @click="save"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)">mdi-pencil</v-icon>
        <v-icon size="small" @click="deleteItem(item)">mdi-delete</v-icon>
      </template>
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>
    </v-data-table-virtual>
  </div>
</template>
